package it.trekker.db;

import java.io.Serializable;
import java.util.Date;

public class Excursion implements Serializable {

	private int id;
	private String name;
	private Date date;
	private double distance;
	private double totAltitudeDifference;
	private long time;
	private double meanPace;
	private long steps;
	
	
	public Excursion() {
		this(-1, null, null);
	}
	
	public Excursion(String name) {
		this(-1, name, null);
	}
	
	public Excursion(int id, String name, Date date) {
		this.id = id;
		this.name = name;
		this.date = date;
		this.steps = 0;
	}
	

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public Date getDate() {
		return date;
	}

	public void setDate(Date date) {
		this.date = date;
	}
	
	public double getDistance() {
		return distance;
	}

	public void setDistance(double distance) {
		this.distance = distance;
	}

	public double getTotAltitudeDifference() {
		return totAltitudeDifference;
	}

	public void setTotAltitudeDifference(double totAltitudeDifference) {
		this.totAltitudeDifference = totAltitudeDifference;
	}

	public long getTime() {
		return time;
	}

	public void setTime(long time) {
		this.time = time;
	}

	public double getMeanPace() {
		return meanPace;
	}

	public void setMeanPace(double meanPace) {
		this.meanPace = meanPace;
	}

	public long getSteps() {
		return steps;
	}

	public void setSteps(long steps) {
		this.steps = steps;
	}

	@Override
	public String toString() {
		return String.format("id: %d - name: %s - date: %s", id, name, date);
	}
	
}
