package it.trekker.db;

import java.io.Serializable;
import java.util.Date;

import android.location.Location;

public class ExcursionCoordinate implements Serializable {
	
	private long id;
	private GPSCoordinate coordinate;
	private Date timestamp;
	private long excursionId;
	
	public ExcursionCoordinate() {
	}
	
	public ExcursionCoordinate(Location location) {
		coordinate = new GPSCoordinate(location);
		this.id = -1;
		this.excursionId = -1;
	}
	
	public long getId() {
		return id;
	}
	
	public void setId(long id) {
		this.id = id;
	}
	
	public GPSCoordinate getCoordinate() {
		return coordinate;
	}

	public void setCoordinate(GPSCoordinate coordinate) {
		this.coordinate = coordinate;
	}

	public Date getTimestamp() {
		return timestamp;
	}
	
	public void setTimestamp(Date timestamp) {
		this.timestamp = timestamp;
	}
	
	public long getExcursionId() {
		return excursionId;
	}
	
	public void setExcursionId(long excursionId) {
		this.excursionId = excursionId;
	}
	
	@Override
	public String toString() {
		return String.format("id: %d - time: %s - exc: %d - %s", 
				id, timestamp, excursionId, coordinate);
	}
	
	@Override
	public boolean equals(Object o) {
		if(o == null)
			return false;
		if(this == o)
			return true;
		if(!(o instanceof ExcursionCoordinate))
			return false;
		
		ExcursionCoordinate other = (ExcursionCoordinate) o;
		
		if(this.coordinate != other.coordinate)
			return false;
		if(this.excursionId != other.excursionId)
			return false;
		if(!this.timestamp.equals(other.timestamp))
			return false;
		
		return true;
	}
}
